function getElementData(triggerLink) {
    var data = {};
    [].filter.call(triggerLink.attributes, function (at) { return /^data-/.test(at.name); })
        .map(function (attribute) { return attribute.name; })
        .forEach(function (name) { return data[name.substr(5)] = triggerLink.getAttribute(name); });
    return data;
}
var activate = function (sourceDOMElement, eventType, bootstrapHandler) {
    var data = getElementData(sourceDOMElement);
    bootstrapHandler({
        sourceDOMElement: sourceDOMElement,
        eventType: eventType,
        data: data,
    });
};
function applyTriggerElementWatch(elements, eventType, bootstrapHandler) {
    elements.forEach(function (element) {
        if (element.dataset.attached !== 'true') {
            if (eventType === 'load') {
                activate(element, eventType, bootstrapHandler);
            }
            else {
                element.addEventListener(eventType, function (event) {
                    event.preventDefault();
                    activate(element, eventType, bootstrapHandler);
                });
            }
            element.dataset.monitored = 'true'; // eslint-disable-line no-param-reassign
        }
    });
}
export default function supportBootstrapping(instance, eventType, onBootstrap) {
    var monitor = instance.container.get('bootstrapping.monitor');
    if (monitor) {
        monitor.events.subscribe('bootstrap:trigger-elements-updated', function (event, data) {
            applyTriggerElementWatch(data.triggerElements, eventType, onBootstrap);
        });
    }
    var triggerElements = instance.container.get('triggerElements');
    if (triggerElements) {
        applyTriggerElementWatch(triggerElements, eventType, onBootstrap);
    }
}
//# sourceMappingURL=support-bootstrapping.js.map