"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function queryPreRenderedTargets(root, bindings) {
    return Array.from(root.querySelectorAll('div[id^="humany_"]'))
        .map(function (element) {
        var widgetName = element.id.substr(7);
        return { widgetName: widgetName, element: element };
    });
}
exports.queryPreRenderedTargets = queryPreRenderedTargets;
var createRegExp = function (bindings) {
    var escapedBindings = bindings.map(function (binding) { return binding.replace(/\./g, '\\.'); }).join('|');
    return new RegExp('^((http[s]?:)?\/\/)?(' + escapedBindings + ')\/([^\\s]+)');
};
// TODO: Handle relative urls when also baseURI is set
var getLinkUrl = function (element) { return element.href; };
function queryLinkTargets(root, bindings) {
    var regex = createRegExp(bindings);
    var destructLinkElement = function (element) {
        var matches = regex.exec(getLinkUrl(element));
        if (matches) {
            return {
                element: element,
                widget: matches[4],
            };
        }
        return null;
    };
    return Array.from(root.querySelectorAll('a'))
        .map(function (element) { return destructLinkElement(element); })
        .filter(function (data) { return !!data; })
        .map(function (data) {
        return {
            element: data.element,
            widgetName: data.widget,
        };
    });
}
exports.queryLinkTargets = queryLinkTargets;
//# sourceMappingURL=target-queries.js.map